package com.chinaweal.aiccs.config;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;
import com.baomidou.mybatisplus.core.config.GlobalConfig;
import com.baomidou.mybatisplus.extension.spring.MybatisSqlSessionFactoryBean;
import com.chinaweal.aiccs.config.handler.LocalUserMetaObjectHandler;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

import javax.sql.DataSource;

/**
 * aiceps 年报系统的数据源
 */

@Configuration
@MapperScan(basePackages = {"com.chinaweal.aiccs.aiceps.**.mapper"}, sqlSessionTemplateRef = "aicepsSqlSessionTemplate")
public class AicepsDataSource {


//    @Bean(name = "aicepsDS", initMethod = "init", destroyMethod = "close")
    @Bean(name = "aicepsDS")
    @ConfigurationProperties(prefix = "spring.datasource.aiceps")
    public DruidDataSource dataSource() {
        return DruidDataSourceBuilder.create().build();
    }

    @Bean(name = "aicepsSqlSessionFactory")
    public MybatisSqlSessionFactoryBean sqlSessionFactory(@Qualifier("aicepsDS") DataSource dataSource) throws Exception {
        MybatisSqlSessionFactoryBean bean = new MybatisSqlSessionFactoryBean();
        bean.setDataSource(dataSource);
        GlobalConfig globalConfig = new GlobalConfig();
        globalConfig.setMetaObjectHandler(new LocalUserMetaObjectHandler());
        bean.setGlobalConfig(globalConfig);
        bean.setConfigLocation(new ClassPathResource("mybatis/mybatis-config.xml"));
        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath*:mybatis/mapper/aiccs/**/*.xml"));
        return bean;
    }

    @Bean(name = "aicepsTransactionManager")
    public DataSourceTransactionManager transactionManager(@Qualifier("aicepsDS") DataSource dataSource) {
        DataSourceTransactionManager dataSourceTransactionManager = new DataSourceTransactionManager(dataSource);
        dataSourceTransactionManager.setEnforceReadOnly(true);
        return dataSourceTransactionManager;
    }

    @Bean(name = "aicepsSqlSessionTemplate")
    public SqlSessionTemplate sqlSessionTemplate(@Qualifier("aicepsSqlSessionFactory") SqlSessionFactory sqlSessionFactory) {
        return new SqlSessionTemplate(sqlSessionFactory);
    }
}
